# ==================================================================
# Plugins::GForum::NewXPosts - Auto Generated Install Module
#
#   Plugins::GForum::NewXPosts
#   Author  : Paul Wilson
#   Version : 0.0.1
#   Updated : Mon Dec  3 18:57:39 2001
#
# ==================================================================
#

package Plugins::GForum::NewXPosts;
# ==================================================================
use strict;
use vars  qw/$VERSION $DEBUG $NAME $META/;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use GForum qw/$IN $DB $CFG/;

$VERSION = '0.0.1';
$DEBUG   = 0;
$NAME    = 'NewXPosts';
# Inhert from base class for debug and error methods
@Plugins::GForum::NewXPosts::ISA = qw(GT::Base);

$META = {
    'prog_ver' => '1.0.0',
    'description' => 'Show the newest X posts using SSI.',
    'license' => 'Freeware',
    'url' => 'http://www.wiredon.net/',
    'author' => 'Paul Wilson',
    'version' => '0.0.1'
};


sub pre_install {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they install
# the plugin.
#
    my $inst_msg = 'Install the New X Posts plugin.';

    return $inst_msg;
}

sub pre_uninstall {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they remove the
# plugin.
#
    my $uninst_msg = 'Uninstall the New X Posts plugin.';

    return $uninst_msg;
}

sub install {
# -------------------------------------------------------------------
# This function does the actual installation. It's first argument is
# a plugin manager which you can use to register hooks, install files,
# add menu options, etc. The second argument is a GT::Tar object which
# you can use to access any files in your plugin module.
#
# You should return an HTML formatted string that will be displayed 
# to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GForum::NewXPosts::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_menu ( 'NewXPosts', [ ['About', 'admin.cgi?do=plugin&plugin=NewXPosts&func=about'] ] );
    $mgr->install_options ( 'NewXPosts', [ ['Show Count', '1', 'Set to 1 to count the posts or 0 for no count.', '', []
, []
, '' ] ] );
    $mgr->install_options ( 'NewXPosts', [ ['Number', '10', 'Number of new posts to show.', '', []
, []
, '' ] ] );

# Silence warnings
    $GT::Tar::error ||= '';

# The following section will unarchive attached files into the 
# proper location.
    my $file;

# Copying newposts.cgi to $CFG->{cgi_root_path} directory.
    $file = $tar->get_file ('newposts.cgi');
 my $code = $file->body_as_string; 
    $code =~ s/^#!(.*)/#!$CFG->{path_to_perl}/; 
    $code =~ s/use lib '[^']+'/use lib '$CFG->{admin_root_path}'/; 
    $file->body ($code); 
    $file->name("$CFG->{cgi_root_path}/newposts.cgi");
    $file->write or return NewXPosts->error("Unable to extract file: '$CFG->{cgi_root_path}/newposts.cgi' ($GT::Tar::error)", 'WARN');
    ;
    return "The plugin has been successfully installed!";
}

sub uninstall {
# -------------------------------------------------------------------
# This function removes the plugin. It's first argument is
# also a plugin manager which you can use to register hooks, install files,
# add menu options, etc. You should return an HTML formatted string
# that will be displayed to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GForum::NewXPosts::error
#
    my $mgr = shift;
    
    $mgr->uninstall_menu ( 'NewXPosts', [ ['About', 'admin.cgi?do=plugin&plugin=NewXPosts&func=about'] ] );
    $mgr->uninstall_options ( 'NewXPosts', [ ['Show Count', '1', 'Set to 1 to count the posts or 0 for no count.', '', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'NewXPosts', [ ['Number', '10', 'Number of new posts to show.', '', []
, []
, '' ] ] );
    ;
    unlink "$CFG->{cgi_root_path}/newposts.cgi";
    return "The plugin has been successfully removed!";
}

1;
